package sk.upjs.js;

import java.util.List;

import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.test.annotation.AbstractAnnotationAwareTransactionalTests;

public class JUnitTest extends AbstractAnnotationAwareTransactionalTests {
	private HibernateTemplate hibernateTemplate;
	
	public JUnitTest() {
		super();
		applicationContext = new ClassPathXmlApplicationContext("applicationContext.xml");
		this.hibernateTemplate = (HibernateTemplate) applicationContext.getBean("hibernateTemplate");
	}
	
	public void testStudentiPredmetu() {
		Predmet p = (Predmet) hibernateTemplate.get(Predmet.class, 8);
		
		System.out.println(p.getNazov());
		for (Student s : p.getStudenti()) {
			System.out.println(s);
		}		
	}
	
	public void testDatabase() {
		Database db = (Database) applicationContext.getBean("database");
		List<Student> studenti = db.listStudents();
		for (Student student : studenti) {
			System.out.println(student);
			System.out.println(student.getPredmety().size());
		}
	}
}
