package sk.upjs.js;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
public class Student implements Serializable {
	@Id
	@GeneratedValue(strategy=GenerationType.AUTO)
	private Integer id;
	
	private String meno;
	
	private String priezvisko;
	
	private int rocnik;

	@OneToMany(mappedBy="studenti")
	private Set<Predmet> predmety = new HashSet<Predmet>();
	
	/**
	 * Przdny kontruktor
	 */
	public Student() {
		// do nothing
	}
	
	public Student(Integer id) {
		this(id, null, null, 0);
	}
	
	
	public Student(Integer id, String meno, String priezvisko, int rocnik) {
		super();
		this.id = id;
		this.meno = meno;
		this.priezvisko = priezvisko;
		this.rocnik = rocnik;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getMeno() {
		return meno;
	}

	public void setMeno(String meno) {
		this.meno = meno;
	}

	public String getPriezvisko() {
		return priezvisko;
	}

	public void setPriezvisko(String priezvisko) {
		this.priezvisko = priezvisko;
	}
	
	public int getRocnik() {
		return rocnik;
	}
	
	public void setRocnik(int rocnik) {
		this.rocnik = rocnik;
	}
	
	public Set<Predmet> getPredmety() {
		return predmety;
	}

	public void setPredmety(Set<Predmet> predmety) {
		this.predmety = predmety;
	}

	@Override
	public String toString() {
		return String.format("%s %s, %s [%s]", meno, priezvisko, rocnik, id);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((meno == null) ? 0 : meno.hashCode());
		result = prime * result + ((predmety == null) ? 0 : predmety.hashCode());
		result = prime * result + ((priezvisko == null) ? 0 : priezvisko.hashCode());
		result = prime * result + rocnik;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Student other = (Student) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (meno == null) {
			if (other.meno != null)
				return false;
		} else if (!meno.equals(other.meno))
			return false;
		if (predmety == null) {
			if (other.predmety != null)
				return false;
		} else if (!predmety.equals(other.predmety))
			return false;
		if (priezvisko == null) {
			if (other.priezvisko != null)
				return false;
		} else if (!priezvisko.equals(other.priezvisko))
			return false;
		if (rocnik != other.rocnik)
			return false;
		return true;
	}
	
	
}
